## lastz 1.04.03

=== Makefile ===
include make-include.mak

default: build_lastz

lastz_32: build_lastz_32

#---------
# builds/installation
#---------

build: build_lastz

build_lastz:
	cd src && ${MAKE} lastz lastz_D

build_lastz_32:
	cd src && ${MAKE} lastz_32

build_test_version:
	cd src && ${MAKE} lastz-test lastz_D-test

install: install_lastz

install_lastz:
	cd src && ${MAKE} install

install_32:
	cd src && ${MAKE} install_32

install_test_version:
	cd src && ${MAKE} install_test_version

# cleanup

clean:
	cd src && ${MAKE} clean

cleano:
	cd src && ${MAKE} cleano

#---------
# testing
#
# test:
#	A small test to give some comfort level that the program has built properly,
#	or that changes you've made to the source code haven't broken it. If the
#	test succeeds, there will be no output from the diff.
# base_tests:
#	More extensive tests (but still small). The results should be of this form:
#	SUCCESS: ../test_data/xxx and ../test_results/yyy are equivalent
#---------

test:
	cd src && ${MAKE} test

base_tests:
	cd src && ${MAKE} base_tests

clean_test: clean_tests

clean_tests:
	cd src && ${MAKE} clean_tests

=== debian/changelog ===
lastz (1.04.03-4) unstable; urgency=medium

  * Really fix build issue
  * Fix spelling

 -- Andreas Tille <tille@debian.org>  Thu, 15 Oct 2020 13:16:55 +0200

lastz (1.04.03-3) unstable; urgency=medium

  * Fix Build issue on a couple of architectures

 -- Andreas Tille <tille@debian.org>  Thu, 15 Oct 2020 11:30:04 +0200

lastz (1.04.03-2) unstable; urgency=medium

  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Tue, 16 Jun 2020 20:19:17 +0200

lastz (1.04.03-1) unstable; urgency=medium

  * Initial release (Closes: #962896)

 -- Andreas Tille <tille@debian.org>  Mon, 15 Jun 2020 21:36:37 +0200

=== debian/control ===
Source: lastz
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/lastz
Vcs-Git: https://salsa.debian.org/med-team/lastz.git
Homepage: https://github.com/lastz/lastz
Rules-Requires-Root: no

Package: lastz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: pairwise aligning DNA sequences
 LASTZ is a drop-in replacement for BLASTZ, and is backward compatible with
 BLASTZ’s command-line syntax. That is, it supports all of BLASTZ’s options
 but also has additional ones, and may produce slightly different alignment
 results.

Package: lastz-examples
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: pairwise aligning DNA sequences (examples and test scripts)
 LASTZ is a drop-in replacement for BLASTZ, and is backward compatible with
 BLASTZ’s command-line syntax. That is, it supports all of BLASTZ’s options
 but also has additional ones, and may produce slightly different alignment
 results.
 .
 This package contains example data and test scripts.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/lastz/lastz/releases .*/archive/v?@ANY_VERSION@\.tar\.gz

## lastz 1.04.15

=== src/Makefile ===
include ../make-include.mak
include version.mak

CC=gcc

# default targets

default: lastz lastz_D

special: lastz_32

builds = lastz lastz_D lastz_32

#---------
# program build
#
# normally creates two versions:
#	lastz:    standard lastz (integer scoring)
#	lastz_D:  lastz with double-float scoring
#
# and can also create this special version:
#	lastz_32: standard lastz with 32-bit sequence indexing
#
#---------
# build-time options (presently only one)
#
# This will enable certain options within the compiled program. To build with
# one of these option, you would do "make lastz <option_name>=ON". The result
# will be an executable named lastz, i.e. mostly indistinguishable from the
# executable without this option. The only place the executable will report
# the option is in response to "lastz --version".
#
# So, for example,
#	make lastz_32 allowBackToBackGaps=ON
# will build with allowBackToBackGaps set to ON.
#
# Note that you should do a "make clean" before doing a build with one of these
# options; otherwise there is no guarantee that all modules will get built with
# the same option settings.
#
#	allowBackToBackGaps		gapped_extend.c is modified to allow the opening of
#							.. a delete right after an insert, or vice versa
#
#---------
# Notes re optimization flags:
#
#	On a 2GHz intel core duo iMac:
#
# 		O3 is a definite improvement over no optimization, improving many of
#		the most-used routines down to as low as 60 to 70% of unoptimized run
#		time.
#
#		However, using -funroll-loops actually slowed things down a little.
#
#---------

definedForAll = -Wall -Wextra -Werror -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
flagsFor32    = -Dmax_sequence_index=32 -Dmax_malloc_index=40 -Ddiag_hash_size=4194304

allowBackToBackGaps ?= 0                       # by default allowBackToBackGaps
ifeq ($(allowBackToBackGaps), ON)              # .. is off;  see note above for
	definedForAll += -DallowBackToBackGaps     # .. how to turn it on
endif


VERSION_FLAGS= \
	-DVERSION_MAJOR="\"${VERSION_MAJOR}"\" \
	-DVERSION_MINOR="\"${VERSION_MINOR}"\" \
	-DVERSION_SUBMINOR="\"${VERSION_SUBMINOR}"\" \
	-DREVISION_DATE="\"${REVISION_DATE}"\" \
	-DSUBVERSION_REV="\"${SUBVERSION_REV}"\"


CFLAGS = -O3 ${definedForAll} ${VERSION_FLAGS}


srcFiles = lastz infer_scores \
           seeds pos_table quantum seed_search diag_hash                  \
           chain gapped_extend tweener masking                            \
           segment edit_script                                            \
           identity_dist coverage_dist continuity_dist                    \
           output gfa lav axt maf cigar sam genpaf text_align align_diffs \
           utilities dna_utilities sequences capsule

incFiles = lastz.h infer_scores.h \
           seeds.h pos_table.h quantum.h seed_search.h diag_hash.h                            \
           chain.h gapped_extend.h tweener.h masking.h                                        \
           segment.h edit_script.h                                                            \
           identity_dist.h coverage_dist.h continuity_dist.h                                  \
           output.h gfa.h lav.h axt.h maf.h sam.h cigar.h genpaf.h text_align.h align_diffs.h \
           utilities.h dna_utilities.h sequences.h capsule.h

%.o: %.c version.mak ${incFiles}
	${CC} -c ${CFLAGS} -Dscore_type=\'I\' $< -o $@

%_D.o: %.c version.mak ${incFiles}
	${CC} -c ${CFLAGS} -Dscore_type=\'D\' $< -o $@

%_32.o: %.c version.mak ${incFiles}
	${CC} -c ${CFLAGS} ${flagsFor32} $< -o $@


lastz: $(foreach part,${srcFiles},${part}.o)
	${CC} $(foreach part,${srcFiles},${part}.o) -lm -o $@

lastz_D: $(foreach part,${srcFiles},${part}_D.o)
	${CC} $(foreach part,${srcFiles},${part}_D.o) -lm -o $@

lastz_32: $(foreach part,${srcFiles},${part}_32.o)
	${CC} $(foreach part,${srcFiles},${part}_32.o) -lm -o $@

# cleanup

clean: cleano clean_builds clean_tests

cleano:
	rm -f *.o

clean_builds:
	rm -f lastz
	rm -f lastz_D
	rm -f lastz_32

# installation;  change installDir to suit your needs (in ../make-include.mak)

install: lastz lastz_D
	${INSTALL} -d      ${installDir}
	${INSTALL} lastz   ${installDir}
	${INSTALL} lastz_D ${installDir}

install_lastz: lastz
	${INSTALL} -d    ${installDir}
	${INSTALL} lastz ${installDir}

install_D: lastz_D
	${INSTALL} -d      ${installDir}
	${INSTALL} lastz_D ${installDir}

install_32: lastz_32
	${INSTALL} -d       ${installDir}
	${INSTALL} lastz_32 ${installDir}

#---------
# testing
#
# Small tests to give some comfort level that the program has built properly,
# or that changes you've made to the source code haven't broken it. The
# results of lav_compare should be of this form:
#	SUCCESS: ../test_data/xxx and ../test_results/yyy are equivalent
#
# Note that a simple diff could be used in most cases, except that there will
# be some mismatches due to version number differences. For the overweight
# seed test, diff is useless since the files being compared will have seed hits
# in different orders.
#
# The tests:
#   test                        Same as base_test_default, but success is silent
#                               (this is included for backward compatibility)
#	base_test_hits				Seed hits only
#	base_test_hsp				HSP alignments only
#	base_test_adaptive_k		HSP alignments only, adaptive-K
#	base_test_default			Default alignment (gapped without chaining)
#	base_test_axt				AXT output format
#	base_test_chained			chained HSPs
#	base_test_extended			gapped alignments
#	base_test_interpolated		interpolated alignments
#	base_test_segments			reading and writing anchor segments
#	base_test_stdin2			sequence2 comes from stdin
#	base_test_2bit1				sequence1 comes from .2bit file
#	base_test_2bit2				sequence2 comes from .2bit file
#	base_test_float				floating point scoring
#	base_test_seeded			non-standard seed pattern
#	base_test_hw_seeded			half weight seed pattern
#	base_test_ow_seeded			overweight seed pattern
#	base_test_masking			dynamic masking
#	base_test_anchors			external anchors
#	base_test_anchors_multi		external anchors with multi-sequence file
#	base_test_subrange			sequence subranges
#	base_test_mask				sequence masking
#	base_test_coi				contigs-of-interest file
#	base_test_multi				multi-sequence file
#	base_test_multi_subrange	multi-sequence file with subranges
#---------

lavCompare = ../tools/lav_compare.py
gfaCompare = ../tools/gfa_compare.py
axtCompare = ../tools/axt_compare.py
mafSort    = ../tools/maf_sort.py

clean_test: clean_tests

clean_tests:
	rm -f ../test_results/base_test*.*

test: lastz
	@rm -f ../test_results/base_test.default.lav
	@./lastz                                     \
	  ../test_data/pseudocat.fa                  \
	  ../test_data/pseudopig.fa                  \
	  | sed "s/\"lastz\.[^ ]* //g"               \
	  > ../test_results/base_test.default.lav
	@diff                                        \
	  ../test_data/base_test.default.lav         \
	  ../test_results/base_test.default.lav

base_tests: lastz lastz_D                               \
	base_test_hits                                      \
	base_test_hsp                                       \
	base_test_adaptive_k                                \
	base_test_default                                   \
	base_test_axt                                       \
	base_test_chained                                   \
	base_test_extended                                  \
	base_test_interpolated                              \
	base_test_segments                                  \
	base_test_stdin2                                    \
	base_test_2bit1                                     \
	base_test_2bit2                                     \
	base_test_float                                     \
	base_test_seeded                                    \
	base_test_hw_seeded                                 \
	base_test_ow_seeded                                 \
	base_test_masking                                   \
	base_test_anchors                                   \
	base_test_anchors_multi                             \
	base_test_subrange                                  \
	base_test_mask                                      \
	base_test_coi                                       \
	base_test_multi                                     \
	base_test_multi_subrange

base_tests_non_float: lastz                             \
	base_test_hits                                      \
	base_test_hsp                                       \
	base_test_adaptive_k                                \
	base_test_default                                   \
	base_test_axt                                       \
	base_test_chained                                   \
	base_test_extended                                  \
	base_test_interpolated                              \
	base_test_segments                                  \
	base_test_stdin2                                    \
	base_test_2bit1                                     \
	base_test_2bit2                                     \
	base_test_seeded                                    \
	base_test_hw_seeded                                 \
	base_test_ow_seeded                                 \
	base_test_masking                                   \
	base_test_anchors                                   \
	base_test_anchors_multi                             \
	base_test_subrange                                  \
	base_test_mask                                      \
	base_test_coi                                       \
	base_test_multi                                     \
	base_test_multi_subrange

base_tests_no_stdin2: lastz lastz_D                     \
	base_test_hits                                      \
	base_test_hsp                                       \
	base_test_adaptive_k                                \
	base_test_default                                   \
	base_test_axt                                       \
	base_test_chained                                   \
	base_test_extended                                  \
	base_test_interpolated                              \
	base_test_segments                                  \
	base_test_2bit1                                     \
	base_test_2bit2                                     \
	base_test_float                                     \
	base_test_seeded                                    \
	base_test_hw_seeded                                 \
	base_test_ow_seeded                                 \
	base_test_masking                                   \
	base_test_anchors                                   \
	base_test_anchors_multi                             \
	base_test_subrange                                  \
	base_test_mask                                      \
	base_test_coi                                       \
	base_test_multi                                     \
	base_test_multi_subrange

base_test_hits:
	@rm -f ../test_results/base_test.hits.lav
	@./lastz                                            \
	  ../test_data/pseudocat.fa                         \
	  ../test_data/pseudopig.fa                         \
	  W=8 T=0 --plus --nogfextend --nogapped            \
	  > ../test_results/base_test.hits.lav
	@${lavCompare}                                      \
	  ../test_data/base_test.hits.lav                   \
	  ../test_results/base_test.hits.lav

base_test_hsp:
	@rm -f ../test_results/base_test.hsp.lav
	@./lastz                                            \
	  ../test_data/pseudocat.fa                         \
	  ../test_data/pseudopig.fa                         \
	  C=3 W=8 T=0                                       \
	  > ../test_results/base_test.hsp.lav
	@${lavCompare}                                      \
	  ../test_data/base_test.hsp.lav                    \
	  ../test_results/base_test.hsp.lav

base_test_adaptive_k:
	@rm -f ../test_results/base_test.adaptive_k.gfa
	@./lastz                                            \

=== debian/changelog ===
lastz (1.04.15-2) unstable; urgency=medium

  * Team upload.
  * Add gcc11.patch.  (Closes: #984081)
  * Edit propagate_cflags.patch to propagate CPPFLAGS as well.
  * d/control: lastz-examples explicitly depends on python3:any.

 -- Étienne Mollier <emollier@debian.org>  Tue, 02 Nov 2021 23:12:52 +0100

lastz (1.04.15-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Apply multi-arch hints.
    + lastz-examples: Add Multi-Arch: foreign.

 -- Andreas Tille <tille@debian.org>  Thu, 23 Sep 2021 15:15:18 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                python3
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/lastz
 Vcs-Git: https://salsa.debian.org/med-team/lastz.git
 Homepage: https://github.com/lastz/lastz
@@ -23,7 +23,8 @@
 
 Package: lastz-examples
 Architecture: all
-Depends: ${python3:Depends}, ${misc:Depends}
+Depends: python3:any, ${python3:Depends}, ${misc:Depends}
+Multi-Arch: foreign
 Description: pairwise aligning DNA sequences (examples and test scripts)
  LASTZ is a drop-in replacement for BLASTZ, and is backward compatible with
  BLASTZ’s command-line syntax. That is, it supports all of BLASTZ’s options

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/lastz/lastz/releases .*/v?@ANY_VERSION@\.tar\.gz

## lastz 1.04.22

=== debian/changelog ===
lastz (1.04.22-2) unstable; urgency=medium

  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Fri, 18 Nov 2022 12:25:49 +0100

lastz (1.04.22-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 24 Aug 2022 07:58:31 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                python3
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/lastz
 Vcs-Git: https://salsa.debian.org/med-team/lastz.git
 Homepage: https://github.com/lastz/lastz

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wno-stringop-truncation

%:
	dh $@ --with python3

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) base_tests
	$(MAKE) test
	$(MAKE) clean_test
endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/lastz/lastz/tags .*/v?@ANY_VERSION@\.tar\.gz

## lastz 1.04.52

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,8 @@
 default: build_lastz
 
 lastz_32: build_lastz_32
+
+lastz_40: build_lastz_40
 
 #---------
 # builds/installation
@@ -16,6 +18,9 @@
 build_lastz_32:
 	cd src && ${MAKE} lastz_32
 
+build_lastz_40:
+	cd src && ${MAKE} lastz_40
+
 build_test_version:
 	cd src && ${MAKE} lastz-test lastz_D-test
 
@@ -26,6 +31,9 @@
 
 install_32:
 	cd src && ${MAKE} install_32
+
+install_40:
+	cd src && ${MAKE} install_40
 
 install_test_version:
 	cd src && ${MAKE} install_test_version

=== src/Makefile ===
--- 
+++ 
@@ -7,9 +7,9 @@
 
 default: lastz lastz_D
 
-special: lastz_32
-
-builds = lastz lastz_D lastz_32
+special: lastz_32 lastz_40
+
+builds = lastz lastz_D lastz_32 lastz_40
 
 #---------
 # program build
@@ -18,8 +18,9 @@
 #	lastz:    standard lastz (integer scoring)
 #	lastz_D:  lastz with double-float scoring
 #
-# and can also create this special version:
-#	lastz_32: standard lastz with 32-bit sequence indexing
+# and can also create these special versions:
+#	lastz_32: standard lastz with 32-bit sequence indexing (allows targets <= (allows targets up to about 4.3Gbp)
+#	lastz_40: standard lastz with 40-bit sequence indexing (allows targets <= (allows targets up to about 1.1Tbp)
 #
 #---------
 # build-time options (presently only one)
@@ -56,6 +57,7 @@
 
 definedForAll = -Wall -Wextra -Werror -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
 flagsFor32    = -Dmax_sequence_index=32 -Dmax_malloc_index=40 -Ddiag_hash_size=4194304
+flagsFor40    = -Dmax_sequence_index=63 -Dmax_malloc_index=40 -Ddiag_hash_size=4194304
 
 allowBackToBackGaps ?= 0                       # by default allowBackToBackGaps
 ifeq ($(allowBackToBackGaps), ON)              # .. is off;  see note above for
@@ -91,14 +93,17 @@
            utilities.h dna_utilities.h sequences.h capsule.h
 
 %.o: %.c version.mak ${incFiles}
-	${CC} -c ${CFLAGS} -Dscore_type=\'I\' $< -o $@
+	${CC} -c ${CFLAGS} -Dscore_type=I $< -o $@
 
 %_D.o: %.c version.mak ${incFiles}
-	${CC} -c ${CFLAGS} -Dscore_type=\'D\' $< -o $@
+	${CC} -c ${CFLAGS} -Dscore_type=D $< -o $@
 
 %_32.o: %.c version.mak ${incFiles}
 	${CC} -c ${CFLAGS} ${flagsFor32} $< -o $@
 
+%_40.o: %.c version.mak ${incFiles}
+	${CC} -c ${CFLAGS} ${flagsFor40} $< -o $@
+
 
 lastz: $(foreach part,${srcFiles},${part}.o)
 	${CC} $(foreach part,${srcFiles},${part}.o) -lm -o $@
@@ -108,6 +113,9 @@
 
 lastz_32: $(foreach part,${srcFiles},${part}_32.o)
 	${CC} $(foreach part,${srcFiles},${part}_32.o) -lm -o $@
+
+lastz_40: $(foreach part,${srcFiles},${part}_40.o)
+	${CC} $(foreach part,${srcFiles},${part}_40.o) -lm -o $@
 
 # cleanup
 
@@ -120,6 +128,7 @@
 	rm -f lastz
 	rm -f lastz_D
 	rm -f lastz_32
+	rm -f lastz_40
 
 # installation;  change installDir to suit your needs (in ../make-include.mak)
 
@@ -139,6 +148,10 @@
 install_32: lastz_32
 	${INSTALL} -d       ${installDir}
 	${INSTALL} lastz_32 ${installDir}
+
+install_40: lastz_40
+	${INSTALL} -d       ${installDir}
+	${INSTALL} lastz_40 ${installDir}
 
 #---------
 # testing
@@ -291,16 +304,3 @@
 	  ../test_results/base_test.hits.lav
 
 base_test_hsp:
-	@rm -f ../test_results/base_test.hsp.lav
-	@./lastz                                            \
-	  ../test_data/pseudocat.fa                         \
-	  ../test_data/pseudopig.fa                         \
-	  C=3 W=8 T=0                                       \
-	  > ../test_results/base_test.hsp.lav
-	@${lavCompare}                                      \
-	  ../test_data/base_test.hsp.lav                    \
-	  ../test_results/base_test.hsp.lav
-
-base_test_adaptive_k:
-	@rm -f ../test_results/base_test.adaptive_k.gfa
-	@./lastz                                            \

=== debian/changelog ===
lastz (1.04.52-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.04.52
  * d/patches/*: refresh following new upstream release.
  * nullchar.patch: new: fix build failure with gcc-15. (Closes: #1097151)
  * d/control: declare compliance to standards version 4.7.2.
  * d/patches/*: normalize Last-Update timestamp.
  * d/watch: move to v5 watch Github template.
  * d/control: drop Rules-Requires-Root: this is now default.

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Sep 2025 22:45:39 +0200

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,10 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                python3
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/lastz
 Vcs-Git: https://salsa.debian.org/med-team/lastz.git
 Homepage: https://github.com/lastz/lastz
-Rules-Requires-Root: no
 
 Package: lastz
 Architecture: any

=== debian/watch ===
Version: 5

Template: Github
Owner: lastz
Project: lastz
